unit Main;

{ Main unit for the CAMEL language project. V0.01
  Please modify it, by adding others procedures, functions...
  I actively develop this project and any help would be greatly appreciated.
  If you modify it, please send me the code to this adress: Camel@Wanadoo.fr
  You can also get more informations in ReadMe.txt

  Thanks,
  Colin Laplace
  http://www.bloodshed.nu/camel/
  http://www.bloodshed.nu/
  webmaster@bloodshed.nu
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  LangValMessages,CompEd, StdCtrls, Compiler, RXSplit, Grids, Outline,
  ExtCtrls,CmpUtils,CompilerForm, Code, SpeedBar, Buttons,Decompiler,ShowProc,
  uObjVM, ObjVM, LangValue, VisualValue, LangProc, ProxyValue, FMXUtils,IniFiles,
  Menus,Registry, ComCtrls;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    CompileBut: TButton;
    RxSplitter1: TRxSplitter;
    aCode: TCode;
    SpeedBar1: TSpeedBar;
    SpeedbarSection1: TSpeedbarSection;
    BitBtn1: TBitBtn;
    Memo2: TMemo;
    BitBtn2: TBitBtn;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    SaveVM: TSaveDialog;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Openfile1: TMenuItem;
    Newfile1: TMenuItem;
    Savefile1: TMenuItem;
    N1: TMenuItem;
    SaveVMfile1: TMenuItem;
    N2: TMenuItem;
    Quit1: TMenuItem;
    Execute1: TMenuItem;
    Compile1: TMenuItem;
    Run1: TMenuItem;
    N3: TMenuItem;
    CompileandRun1: TMenuItem;
    Help1: TMenuItem;
    ReadMe1: TMenuItem;
    ErrorList: TListBox;
    Memo1: TRichEdit;
    procedure CompileButClick(Sender: TObject);
    procedure Compiler1Error(Sender: TObject; LineNo, TokenNo,
      ErrorType: Integer; const Token, Msg: string);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Newfile1Click(Sender: TObject);
    procedure ReadMe1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
implementation
uses InputQueryProc,VarLangValue, uRunTime, uConsole;
{$R *.DFM}


procedure TMainForm.CompileButClick(Sender: TObject);
begin
  if CompilerFrm.CompileTo(Memo1.Lines,aCode)
  then
    Caption:='Ok'
  else
    Caption:='Error';
end;

procedure TMainForm.Compiler1Error(Sender: TObject; LineNo, TokenNo,
  ErrorType: Integer; const Token, Msg: string);
begin
  MessageDlg(Format('Error %s %s',[Token,Msg]),mtInformation,[mbOk],0)
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
 ErrorList.Items.Clear; //Clear error list
 Memo2.Clear;           //Clear VM codes
 With TCompilerFrm.Create(nil) do
  begin
    try
    try
      CompileTo(Memo1.Lines,aCode);     //Compile
      Decompile(aCode,Memo2.Lines);     // Show VM codes
     except
      On e:ECompilerError do
      begin
        ErrorList.Items.Insert(e.LineNo,'Line: '+IntToStr(e.LineNo)+' Token:'+IntToStr(e.TokenNo)+': "'+e.Token+'" Error: '+ e.message); //add error to Error list
        ErrorList.SetFocus; // Set the focus to the error list
      end;
      On e:Exception do
      begin
        ErrorList.Items.Insert(ErrorList.Items.Count + 1,'Exception: ' + e.message);
        ErrorList.SetFocus; // Set the focus to the error list
      end;
    end;
    finally Free end;
  end;
end;

procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
  RunTime.VM.Run(aCode); // Run the code after compilation
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    Memo1.Lines.LoadFromFile(OpenDialog.Filename); // Load Camel source code
  end;
end;

procedure TMainForm.BitBtn3Click(Sender: TObject);
begin
BitBtn1Click(Sender);
BitBtn2Click(Sender);
end;

procedure TMainForm.BitBtn6Click(Sender: TObject);
begin
if SaveVM.Execute then
Memo2.Lines.SaveToFile(SaveVM.FileName);     // Save VM codes
end;

procedure TMainForm.BitBtn7Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure TMainForm.BitBtn5Click(Sender: TObject);
begin
if SaveDialog.Execute then
begin
Memo1.Lines.SaveToFile(SaveDialog.FileName);     // Save Camel code
end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var reg: TRegistry;
begin
if ParamStr(1)<>'' then Memo1.Lines.LoadFromFile(ParamStr(1)); // Allow you to launch Camel with a file
{The next code is to allow to execute script with camelint.exe by double-clicking
on a .cam file. You do not need to modify this}
reg := TRegistry.Create;
reg.RootKey := HKEY_CLASSES_ROOT;
reg.OpenKey('.cam' ,true);
Reg.WriteString('','Camel file');
reg.Closekey;
reg.OpenKey('Camel file', true);
reg.Closekey;
reg.OpenKey('Camel file\DefaultIcon', true);
Reg.WriteString('',ExtractFilePath(application.exename)+'camelint.exe');
reg.CloseKey;
reg.OpenKey('Camel file\Shell\Open\Command', true);
Reg.WriteString('',ExtractFilePath(application.exename)+'camelint.exe %1');
reg.CloseKey;
reg.Free;
end;

procedure TMainForm.Newfile1Click(Sender: TObject);
begin
// Clear all memo
Memo1.Clear;
Memo2.Clear;
end;

procedure TMainForm.ReadMe1Click(Sender: TObject);
begin
ExecuteFile(ExtractFilePath(Application.exename)+'ReadMe.txt','',ExtractFilePath(Application.Exename),SW_SHOW);
end;

end.
